/**********************
** Web Server Arduino**
**********************/
 
//Llibreries
#include <SPI.h>
#include <Ethernet.h>

//Assignar IP a la placa
byte mac[] = {0xDE, 0xFD, 0xAE, 0xAF, 0xFE, 0xED };
IPAddress ip(192, 168, 1, 136);

//Rebre peticions HTTP
EthernetServer server(80);
EthernetClient client;

//Variables
int led=6; //Iniciem led en 6
int posicion; //Variable per guardar la posició
String estado=”OFF”; //Iniciem el led en OFF
String cadena;

/***Comunicació Ethernet i servidor***/
void setup() {
  Serial.begin(9600); //Obre port serie amb velocitat 9600 baudios
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  pinMode(led,OUTPUT);
}

/***Servidor***/
/* El que farà serà que quan detecti que el client enviï una petició HTTP aquest el llegirà caràcter per caràcter i d’aquesta forma podrem fer una recerca i veure l’estat del LED. Quan detecti una línia en blanc serà que ha acabat i enviarà la resposta */ 
void loop() {
  EthernetClient client = server.available();
  //Si detecta un client petició HTTP
  if (client) {
    Serial.println("new client");
    boolean currentLineIsBlank = true; //Petició HTTP acaba amb línia en blanc
    while (client.connected()) { //Mentres client connected
      if (client.available()) { //Visualitzem petició HTTP
        char c = client.read(); //Llegim petició HTTP
        Serial.write(c); //Visualitzem petició HTTP
        cadena.concat(c);
        
        //Recerca en la petició
        posicion=cadena.indexOf("LED="); //Guardem posició LED
        //Si posició=ON, estado=ON
        if(cadena.substring(posicion)=="LED=ON"){
         digitalWrite(led,HIGH);
         estado="ON";
       }
       //Si posición=OFF, estado=OFF
       if(cadena.substring(posicion)=="LED=OFF"){
        digitalWrite(led,LOW);
        estado="OFF";
       }
       //Si rep línia en blanc = petició HTTP acabada
        if (c == '\n' && currentLineIsBlank) {
          //Enviem resposta HTTP
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println();
          
          /*** Codi HTML ***/
          /* La nostra web estarà formada per dos botons que engegaran/apagaran el LED que connectarem a la placa. Per poder enviar els paràmetres per mitjà del codi hem de fer servir URL.*/ 
          client.println("<!DOCTYPE html PUBLIC>");
          client.println("<html>");
          client.println("<head><meta content='text/html; charset=utf-8' http-equiv='Content-Type' />");
          client.println("<title></title>");
          client.println("</head>");
          client.println("<body>");
          client.println("<br>");
          client.println("<h1 align='center'> Web Server Arduino</h1>");
          client.println("<div style='text-align:center;'>");
          client.println("<button onClick=location.href='./?LED=ON\ '");
          client.println("ON");
          client.println("</button>");
          client.println("<button onClick=location.href='./?LED=OFF\'"); 
          client.println("OFF");
          client.println("</button>");
          client.println("<br /><br />");
          client.println("<b>LED = ");
          client.print(estado);
          client.println("</b><br />");
          client.println("</b></body>");
          client.println("</html>");

          break;
        }
        if (c == '\n') {
          currentLineIsBlank = true;
        } 
        else if (c != '\r') {
          currentLineIsBlank = false;
        }
      }
    }
    //Control de temps
    delay(1);
    //Tanquem connexió
    client.stop();
    Serial.println("client disonnected");
  }
}
